/*

Mures
Copyright (C) 2001 Adam D'Angelo

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Contact information:

Adam D'Angelo
dangelo@ntplx.net
P.O. Box 1155
Redding, CT 06875-1155
USA

*/

#include "SDL_net.h"
#include "protocol.h"
#include "sim.h"
#include "main.h"

int local_keyboard_player_count()
{
  int i, count=0;
  
  for(i=0; i<MAX_PLAYER; i++)
    if(have_local_player[i])
      if(local_player_type[i] == KEYBOARD_PLAYER)
	count++;

  return count;
}

int local_keyboard_player(int n)
{
  int i,count=0;

  for(i=0; i<MAX_PLAYER; i++)
    if(have_local_player[i])
      if(local_player_type[i] == KEYBOARD_PLAYER) {
	if(count==n)
	  return i;
	count++;
      }

  return -1;
}

char dir_to_char(direction dir)
{
  switch(dir) {
  case up: return 'U'; break;
  case down: return 'D'; break;
  case left: return 'L'; break;
  case right: return 'R'; break;
  default: return '?'; break;
  }
}

direction char_to_dir(char dir)
{
  switch(dir) {
  case 'U': return up; break;
  case 'D': return down; break;
  case 'L': return left; break;
  case 'R': return right; break;
  default: return MAX_DIR; break;
  }
}

char* map_type_to_s(map_type type)
{
  switch(type) {
  case BATTLE: return "Battle"; break;
  default: return "Unknown"; break;
  }
}

int max(int a, int b)
{
  return a>b?a:b;
}

int min(int a, int b)
{
  return a<b?a:b;
}
