/*

Mures
Copyright (C) 2001 Adam D'Angelo

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Contact information:

Adam D'Angelo
dangelo@ntplx.net
P.O. Box 1155
Redding, CT 06875-1155
USA

*/

#include "types.h"

/* screen resolution to use */
#define SCREEN_WIDTH 640
#define SCREEN_HEIGHT 480

/* how many ms on/off during an arrow's flickering */
#define FLICKER_RATE 20
/* how many ms an arrow flickers for */
#define FLICKER_TIME 1300

/* where the grid starts */
#define TOP_BORDER 15
#define LEFT_BORDER TOP_BORDER
#define BOTTOM_BORDER 70
#define RIGHT_BORDER LEFT_BORDER

#define MIN(X,Y) ((X)<(Y)?(X):(Y))

/* block size in pixels, 45 at 640x480 */
/*#define BLOCK_SIZE (MIN(screen->w/NUM_BLOCKS_X, screen->h/NUM_BLOCKS_Y)*85/100)*/
#define BLOCK_SIZE (MIN((screen->w-LEFT_BORDER-RIGHT_BORDER)/NUM_BLOCKS_X, (screen->h-TOP_BORDER-BOTTOM_BORDER)/NUM_BLOCKS_Y))

#define GRID_BOX_THICKNESS (BLOCK_SIZE*5/40)

#define WALL_THICKNESS (BLOCK_SIZE*8/45)

#define WALLPOST_SIZE (WALL_THICKNESS*2-2)


SDL_Surface *screen;

void output_handle_event(int event);

screen_position grid2screen(grid_int_position ongrid);
screen_position gridf2screen(grid_float_position ongrid);

int on_grid(screen_position onscreen);
grid_int_position screen2grid(screen_position onscreen);

void change_screen(int new_width, int new_height);

void output_new_map(sim *s);
void output_refresh(sim *s, keyboard_data *data);

int output_init(int fullscreen);
int output_exit();

void output_screenshot();


